import html2canvas from "html2canvas";

export const captureVisualization = async (): Promise<string | null> => {
  const container = document.getElementById("real-time-vis-canvas");
  if (!container) return null;

  try {
    // Use html2canvas to capture the container
    const canvas = await html2canvas(container, {
      scale: 1, // Adjust scale for higher/lower resolution
    });

    // Convert the canvas to a data URL (PNG format)
    const dataUrl = canvas.toDataURL("image/png");
    return dataUrl;
  } catch (error) {
    console.error("Error capturing visualization:", error);
    return null;
  }
};
